# Tento soubor je potřebný k odevzdávání práce v hodinách.
# Neupravujte jej, nanejvýš byste si tím mohli zkomplikovat práci.
import urllib
import urllib.request
import json
import os
import sys
from uuid import getnode
try:
    import pwd
    getuser = lambda: pwd.getpwuid(os.getuid()).pw_name
except ImportError:
    from getpass import getuser

default_ip = "192.168.110.110"
server = None
token = None

def _submit(data):
    headers = {
        'Content-Type': 'application/json',
        'Accept': 'application/json',
    }
    data = json.dumps(data).encode()
    req = urllib.request.Request(f"{server}/submit", data=data, headers=headers)
    result = urllib.request.urlopen(req).read().decode()
    result = json.loads(result)
    return result

def login(ip=default_ip):
    global token
    global server
    newest = max((f for f in os.listdir(".") if f.endswith(".ipynb")), key=os.path.getmtime)
    ipynb = json.load(open(newest, "r", encoding="utf-8"))
    metadata = ipynb.setdefault("metadata", {})
    init = metadata.get("init", False)
    headers = {
        'Content-Type': 'application/json',
        'Accept': 'application/json',
    }
    data = json.dumps({
        'username': getuser(),
        'password': getnode(),
        'init': init,
    }).encode()
    server = f"http://{ip}:5000"
    req = urllib.request.Request(f"{server}/login", data=data, headers=headers)
    result = urllib.request.urlopen(req).read().decode()
    result = json.loads(result)
    token = result.get("token", "fixme")
    return result.get('success', False)

def colorize(text, color, bold=False):
    codes = {
        'black': 30,
        'red': 31,
        'green': 32,
        'yellow': 33,
        'blue': 34,
        'magenta': 35,
        'cyan': 36,
        'white': 37
    }
    return f"\033[{int(bold)};{codes.get(color, 37)}m{text}\033[0m"

def test(number):
    calling_module = sys.modules["__main__"]
    recent = getattr(calling_module, "In")
    result = _submit({'number': number, 'token': token, 'code': recent[-1]})
    color = 'green' if result.get("accepted") else 'red'
    print(colorize(result.get("message"), color, True))

_version = "2024-04-18.1"